function [Spencer_rates]=SpencerRateCalculate(start_gcn_freq,codon_names);
%% This function calculates rates as specified by Spencer et al 2012
w=3; %Penalizing Wobble Factor
%% First extract amino acid names
amino_list=[];
for i=1:length(codon_names)
    amino_list=[amino_list codon_names{i}(4)];
end
%% Now calculate percentage makeup for each codon NNN%
NNNPercent=zeros(1,length(amino_list));
for i=1:length(amino_list)
    current_amino=amino_list(i);
    locs=strfind((amino_list),current_amino);
    NNNPercent(i)=start_gcn_freq(i)/sum(start_gcn_freq(locs));
end
NNNPercent(isnan(NNNPercent))=0;
%% Now calculate rate for each codon

NNNv=zeros(1,length(amino_list));
for i=1:length(amino_list)
    codon=codon_names{i}(1:3);
    
    %% First do Ile
    if codon=='ATT'
        ATCLoc=find(strncmp(codon_names,'ATC',3));
        NNNv(i)=NNNPercent(i)+NNNPercent(ATCLoc)/w;
    elseif codon=='ATC'
        NNNv(i)=NNNPercent(i);
    elseif codon=='ATA'
    	ATGLoc=find(strncmp(codon_names,'ATG',3));
        NNNv(i)=NNNPercent(ATGLoc)/(w*2); %%MAde changes here

    %% Now do Met
    elseif codon=='ATG'
        NNNv(i)=NNNPercent(i)/2;
    %% Now do Arg
    elseif amino_list(i)=='R'
                    if codon=='AGA' %% The case of arg two-codon group
                        NNNv(i)=NNNPercent(i);
                    elseif codon=='AGG'
                        AGALoc=find(strncmp(codon_names,'AGA',3));
                         NNNv(i)=NNNPercent(i)+NNNPercent(AGALoc)/w;
                         %% The case of arg two-codon group
                    elseif codon=='CGT'
                        CGCLoc=find(strncmp(codon_names,'CGC',3));
                        NNNv(i)=NNNPercent(i)/w+NNNPercent(CGCLoc)/w;
                    elseif codon=='CGC'
                        CGTLoc=find(strncmp(codon_names,'CGT',3));
                        NNNv(i)=NNNPercent(i)+NNNPercent(CGTLoc); 
                    elseif codon=='CGA'
                        CGTLoc=find(strncmp(codon_names,'CGT',3));
                        NNNv(i)=NNNPercent(i)+NNNPercent(CGTLoc)/w;
                    elseif codon=='CGG'
                        CGALoc=find(strncmp(codon_names,'CGA',3));
                        NNNv(i)=NNNPercent(i)+NNNPercent(CGALoc)/w;
                    end
    %% Now do the case for all other codons
    elseif codon(3)=='T'
        NNCLoc=find(strncmp(codon_names,[codon(1:2),'C'],3));
        NNNv(i)=NNNPercent(i)+NNNPercent(NNCLoc)/w;
    elseif codon(3)=='C'
        NNNv(i)=NNNPercent(i);
    elseif codon(3)=='A'
        NNNv(i)=NNNPercent(i);
    elseif codon(3)=='G'
        NNALoc=find(strncmp(codon_names,[codon(1:2),'A'],3));
        NNNv(i)=NNNPercent(i)+NNNPercent(NNALoc)/w; %%  MADE CHANGE HERE
    end
end
Spencer_rates=NNNv;

end